/**
 * @file
 * @brief some test file
 */

/** Private base */
class PrivBase
{
public:
  PrivBase();
};

/** Public base */
class PubBase
{
public:
  PubBase();
};

/** Derived class */
class Derived: public PubBase, private PrivBase
{
private:
  /** Inner private class */
  class PrivateInner
  {
  public:
    PrivateInner();
  };

public:
  /** Inner public class */
  class PublicInner
  {
  public:
    PublicInner();
  };

  /** Constructor */
  Derived();

  /** Public method */
  void foo();
  /** Public member */
  int m_public;

protected:
  /** Protected method */
  void bar();
  /** Protected member */
  int m_protected;

private:
  /** Private method */
  void baz();

  /** Private member */
  int m_private;
  /** Private reference */
  PublicInner m_privateRef;
};
